
clear
mu=0;
sigma=1;
T=50; % Number of observations
const=0;
%%% AR(1)
series=[];
p=[0.1; 0.05];
q=[];

N=10000; % number of replications
for i=1:N
    if mod(i,100)==0
        i
    end
    series(:,1)=arma_generator(T,mu,sigma,p,q,const);
    %%% OLS regression
    lhs=series(3:end,1);
    rhs(:,1)=series(2:end-1,1); % alpha_1
    rhs(:,2)=series(1:end-2,1); % alpha_2
    results=ols(lhs,rhs);
    alpha_ols(i,:)=results.beta; % OLS coefficient
    
    %%% Yule-Walker estimator
    ac=sacf_YW(series,4);
    R=[1 ac(1,1); ac(1,1) 1];
    alpha_YW(i,:)=(inv(R)*ac(1:2,1))';
    
    RR=[1 ac(1,1); ac(1,1) 1; ac(2,1) ac(1,1); ac(3,1) ac(2,1)];
    alpha_YW4(i,:)=inv(RR'*RR)*RR'*ac;
end;

m(1,:)=mean(alpha_ols);
m(2,:)=mean(alpha_YW);
m(3,:)=mean(alpha_YW4);


v(1,:)=var(alpha_ols);
v(2,:)=var(alpha_YW);
v(3,:)=var(alpha_YW4);
    
