%%% Monte Carlo Study

%%% OLS vs. Yule-Walker-Estimation

%%% AR(2)
clear
N=1000; % Number of MC replicaions
T=50; % length of the time series
a1=0.2;
a2=-0.2;
for i=1:N % MC loop
    i
    %%% simulate the AR(2)
    y(1,1)=randn(1,1);
    y(2,1)=randn(1,1);
    for t=3:2*T
        y(t,1)=a1*y(t-1,1)+a2*y(t-2,1)+randn(1,1);
    end;
    AR=y(T+1:end,1);
    
    %%% AR estimation
    y=[];
    y=AR(3:end,1);
    X(:,1)=AR(2:end-1,1); % first lag
    X(:,2)=AR(1:end-2,1); % second lag
    beta=inv(X'*X)*X'*y;
    ar_estimator(i,:)=beta';
    
    %%% Yule-Walker Estimation
    SACF=sacf(AR,2,1,0);
    R=[1 SACF(1,1); SACF(1,1) 1];
    beta=inv(R)*SACF;
    YW_estimator(i,:)=beta';
end;
    
    