function series=arma_generator(N,mu,sigma,p,q,const)

maximum=max(size(q,1),size(p,1));

zufall=normrnd(mu,sigma,2*N,1);

if isempty(p)==0 && isempty(q)==1 %% AR-process
    series=zufall;
    for t=size(p,1)+1:2*N
        series(t,1)=const;
        for i=1:size(p,1)
            series(t,1)=series(t,1)+p(i,1)*series(t-i);
        end
        series(t,1)=series(t,1)+zufall(t,1);
    end
end


if isempty(p)==1 && isempty(q)==0 %% MA-process
    series=zufall;
    for t=size(q,1)+1:2*N
        series(t,1)=const;
        for i=1:size(q,1)
            series(t,1)=series(t,1)+q(i,1)*zufall(t-i);
        end
        series(t,1)=series(t,1)+zufall(t,1);
    end
end
if isempty(p)==0 && isempty(q)==0 %% ARMA-process
    series=zufall;
    for t=maximum+1:2*N
        series(t,1)=const;
        for i=1:size(p,1)
            series(t,1)=series(t,1)+p(i,1)*series(t-i);
        end
        for j=1:size(q,1)
            series(t,1)=series(t,1)+q(j,1)*zufall(t-j,1);
        end
        series(t,1)=series(t,1)+zufall(t,1);
    end
end
series=series(end:-1:end-(N-1),1);
    
