clc
clear

indicators=[];
IP=[];

%%% Generate ARX(1,1) forecasts for each indicator
for i=1:216 % indicator loop
    a=1;
    for t=100:233-1 % time loop over months
        lhs=[];
        rhs=[];
        lhs=IP(2:t);
        rhs(:,1)=ones(t-1,1); % constant
        rhs(:,2)=IP(1:t-1,1); % lagged IP (y_(t-1))
        rhs(:,3)=indicators(1:t-1,i); % indicator i
        %%% OLS
        beta=inv(rhs'*rhs)*rhs'*lhs;
        %%% calculate the forecast
        f(a,i)=beta(1,1)+beta(2,1)*IP(t,1)+beta(3,1)*indicators(t,i);
        error(a,i)=IP(t+1,1)-f(a,i); % forecast error
        
        %%% AR(1) benchmark
        lhs=IP(2:t);
        rhs(:,1)=ones(t-1,1); % constant
        rhs(:,2)=IP(1:t-1,1); % lagged IP (y_(t-1))
        %%% OLS
        beta=inv(rhs'*rhs)*rhs'*lhs;
        %%% calculate the forecast
        f_IP(a,1)=beta(1,1)+beta(2,1)*IP(t,1);
        error_IP(a,1)=IP(t+1,1)-f_IP(a,1); % forecast error
     
        a=a+1;
    end;
end;

%%% Forecast evulation
MSFE_ind=(mean(error.^2))';
MSFE_IP=mean(error_IP.^2);
MAFE=(mean(abs(error)))';
MAFE_IP=mean(abs(error_IP));

combination=mean(f')';

error_c=IP(101:233,1)-combination;
MSFE_c=mean(error_c.^2);
MSFE_crisis(1,1)=mean(error_IP(93:116,1).^2);
MSFE_crisis(2:217,1)=(mean(error(93:116,:).^2))';
